module Mobile
  module Entities
    class News < Grape::Entity
      include Redmine::I18n
      include ApiHelper
      def self.news_expose(field)
        expose field do |f,opt|
          if f.is_a?(Hash) && f.key?(field)
            f[field]
          elsif f.is_a?(::News)
            if f.respond_to?(field)
              if field == :created_on
                format_time(f.send(field))
              else
                f.send(field)
              end
            else
              case field
                when :course_name
                  get_course(f.course_id).name unless f.course_id == nil
                when :praise_count
                  get_activity_praise_num(f)
                when :act_type
                  'News'
                when :act_id
                  f.id
              end
            end
          elsif f.is_a?(Hash) && !f.key?(field)
            n = f[:news]
            comments = f[:comments]
            if n.is_a?(::News)
              if field == :created_on
                format_time(n.send(field)) if n.respond_to?(field)
              else
                n.send(field) if n.respond_to?(field)
              end

            end

          end
        end
      end
      news_expose :id
      #新闻标题
      news_expose :title

      expose :author,using: Mobile::Entities::User do |f, opt|
        obj = nil
        if f.is_a?(::News) && f.respond_to?(:author)
          obj = f.send(:author)
        elsif f.is_a?(Hash) && f.key?(:author)
          obj = f[:author]
        end
        obj
      end
      news_expose :act_type
      news_expose :act_id
      #作者id
      news_expose :author_id
      #作者名
      news_expose :author_name
      #作者头像url
      news_expose :author_img_url
      #新闻内容
      news_expose :description
      #发布时间
      news_expose :created_on
      #评论数量
      news_expose :comments_count
      news_expose :praise_count
      #课程名字
      news_expose :course_name
      #评论
      expose :comments, using: Mobile::Entities::Comment do |f, opt|
        if f.is_a?(Hash) && f.key?(:comments)
          f[:comments]
        elsif f.is_a?(::News) && f.respond_to?(:comments)
          f.comments.reverse
        end
      end
      expose :has_praise , if: lambda { |instance, options| options[:user] } do |instance, options|
        has_praise = false
        current_user = options[:user]
        obj = PraiseTread.where("praise_tread_object_id=? and praise_tread_object_type=? and user_id=?",instance.id,instance.class.to_s,current_user.id)
        has_praise = obj.empty? ? false : true
        has_praise
      end
    end
  end
end